// -*-C++-*-
/*!
 * @file  ConstantSVC_impl.cpp
 * @brief Service implementation code of Constant.idl
 *
 */

#include "ConstantSVC_impl.h"
#include <iostream>
#include <string>

#define SHORT 1
#define LONG 2
#define FLOAT 3
#define DOUBLE 4

/*
 * Example implementational code for IDL interface constant
 */
constantSVC_impl::constantSVC_impl()
{
  // Please add extra constructor code here.
}


constantSVC_impl::~constantSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
extern bool svc_flag;
extern int svc_type;
extern double svc_out;
extern bool execute_flag;

CORBA::Long constantSVC_impl::SetStatus(CORBA::Long& datatype, CORBA::Double& output)
{
  if(datatype!=SHORT && datatype!=LONG && datatype!=FLOAT && datatype!=DOUBLE){
    std::cout << "DataType ERROR." << std::endl;
    return -1;
  }

  svc_flag = true;
  svc_type = (int)datatype;
  svc_out = output;

  return 0;
}

CORBA::Double constantSVC_impl::GetOutput()
{
  return svc_out;
}

CORBA::Long constantSVC_impl::SetOutput(CORBA::Double& output)
{
  svc_flag = true;
  svc_out = output;

  return 0;
}

CORBA::Long constantSVC_impl::StartOutput()
{
  execute_flag = true;
  return 0;
}

CORBA::Long constantSVC_impl::StopOutput()
{
  execute_flag = false;
  return 0;
}



// End of example implementational code



