// -*-C++-*-
/*!
 * @file  ConverterSVC_impl.cpp
 * @brief Service implementation code of Converter.idl
 *
 */

#include "ConverterSVC_impl.h"
#include <iostream>

#define SHORT 1
#define LONG 2
#define FLOAT 3
#define DOUBLE 4
#define BOOL 5
#define SHORTARRAY 10
#define LONGARRAY 20
#define FLOATARRAY 30
#define DOUBLEARRAY 40
#define BOOLARRAY 50

/*
 * Example implementational code for IDL interface converter
 */
converterSVC_impl::converterSVC_impl()
{
  // Please add extra constructor code here.
}


converterSVC_impl::~converterSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
extern bool svc_flag;
extern int svc_intype;
extern int svc_outtype;
extern int svc_extra;

CORBA::Long converterSVC_impl::SetStatus(CORBA::Long& inport_datatype, CORBA::Long& outport_datatype, CORBA::Long& extra_num)
{
  if(inport_datatype!=SHORT && inport_datatype!=LONG && inport_datatype!=FLOAT && inport_datatype!=DOUBLE && 
     inport_datatype!=BOOL  && inport_datatype!=SHORTARRAY && inport_datatype!=LONGARRAY &&
     inport_datatype!=FLOATARRAY && inport_datatype!=DOUBLEARRAY && inport_datatype!=BOOLARRAY){
    std::cout << "InPort_DataType ERROR." << std::endl;
    return -1;
  }
  if(outport_datatype!=SHORT && outport_datatype!=LONG && outport_datatype!=FLOAT && outport_datatype!=DOUBLE && 
     outport_datatype!=BOOL  && outport_datatype!=SHORTARRAY && outport_datatype!=LONGARRAY &&
     outport_datatype!=FLOATARRAY && outport_datatype!=DOUBLEARRAY && outport_datatype!=BOOLARRAY){
    std::cout << "OutPort_DataType ERROR." << std::endl;
    return -1;
  }
  if(extra_num < 1 || 10 < extra_num){
    std::cout << "Extra_Num ERROR." << std::endl;
    return -1;
  }
  svc_flag    = true;
  svc_intype  = (int)inport_datatype;
  svc_outtype = (int)outport_datatype;
  svc_extra   = (int)extra_num;

  return 0;
}



// End of example implementational code



