// -*-C++-*-
/*!
 * @file  FileReaderSVC_impl.cpp
 * @brief Service implementation code of FileReader.idl
 *
 */

#include "FileReaderSVC_impl.h"
#include <iostream>
#include <string>

#define SHORT 1
#define LONG 2
#define FLOAT 3
#define DOUBLE 4
#define SHORTARRAY 10
#define LONGARRAY 20
#define FLOATARRAY 30
#define DOUBLEARRAY 40

/*
 * Example implementational code for IDL interface filereader
 */
filereaderSVC_impl::filereaderSVC_impl()
{
  // Please add extra constructor code here.
}


filereaderSVC_impl::~filereaderSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
extern bool svc_flag;
extern bool svcname_flag;
extern int svc_type;
extern std::string svc_outputdata;
extern int svc_arraysize;
extern bool execute_flag;

CORBA::Long filereaderSVC_impl::SetStatus(CORBA::Long& datatype, const char* outputdata, CORBA::Long& arraysize)
{
  if(datatype!=SHORT && datatype!=LONG && datatype!=FLOAT && datatype!=DOUBLE && datatype!=SHORTARRAY && datatype!=LONGARRAY && datatype!=FLOATARRAY && datatype!=DOUBLEARRAY){
    std::cout << "DataType ERROR." << std::endl;
    return -1;
  }

  svc_flag = true;
  svc_type = datatype;
  svc_outputdata = outputdata;
  svc_arraysize = arraysize;

  return 0;
}

CORBA::Long filereaderSVC_impl::StartOutput()
{
  svc_flag  = true;
  execute_flag = true;

  return 0;
}

CORBA::Long filereaderSVC_impl::StopOutput()
{
  svc_flag  = true;
  execute_flag = false;

  return 0;
}

extern bool svc_reset;

CORBA::Long filereaderSVC_impl::ResetOutput()
{
  svc_reset = true;

  return 0;
}



// End of example implementational code



