// -*-C++-*-
/*!
 * @file  GainerSVC_impl.cpp
 * @brief Service implementation code of Gainer.idl
 *
 */

#include "GainerSVC_impl.h"
#include <iostream>

#define SHORT 1
#define LONG 2
#define FLOAT 3
#define DOUBLE 4
#define SHORTARRAY 10
#define LONGARRAY 20
#define FLOATARRAY 30
#define DOUBLEARRAY 40

/*
 * Example implementational code for IDL interface gainer
 */
gainerSVC_impl::gainerSVC_impl()
{
  // Please add extra constructor code here.
}


gainerSVC_impl::~gainerSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
extern bool svc_flag;
extern int svc_type;
extern double svc_gain;

CORBA::Long gainerSVC_impl::SetStatus(CORBA::Long& datatype, CORBA::Double& gain)
{
  if(datatype!=SHORT      && datatype!=LONG      && datatype!=FLOAT      && datatype!=DOUBLE && 
     datatype!=SHORTARRAY && datatype!=LONGARRAY && datatype!=FLOATARRAY && datatype!=DOUBLEARRAY){
    std::cout << "DataType ERROR." << std::endl;
    return -1;
  }

  svc_flag = true;
  svc_type = (int)datatype;
  svc_gain = gain;

  return 0;
}

CORBA::Double gainerSVC_impl::GetGain()
{
  return svc_gain;
}

CORBA::Long gainerSVC_impl::SetGain(CORBA::Double& gain)
{
  svc_flag = true;
  svc_gain = gain;

  return 0;
}



// End of example implementational code



