// -*-C++-*-
/*!
 * @file  LimiterSVC_impl.cpp
 * @brief Service implementation code of Limiter.idl
 *
 */

#include "LimiterSVC_impl.h"
#include <iostream>
#include <string>

#define SHORT 1
#define LONG 2
#define FLOAT 3
#define DOUBLE 4
#define SHORTARRAY 10
#define LONGARRAY 20
#define FLOATARRAY 30
#define DOUBLEARRAY 40

/*
 * Example implementational code for IDL interface limiter
 */
limiterSVC_impl::limiterSVC_impl()
{
  // Please add extra constructor code here.
}


limiterSVC_impl::~limiterSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
extern bool svc_flag;
extern int svc_type;
extern double svc_max;
extern double svc_min;

CORBA::Long limiterSVC_impl::SetStatus(CORBA::Long& datatype, CORBA::Double& limitmax, CORBA::Double& limitmin)
{
  if(datatype!=SHORT && datatype!=LONG && datatype!=FLOAT && datatype!=DOUBLE && datatype!=SHORTARRAY && datatype!=LONGARRAY && datatype!=FLOATARRAY && datatype!=DOUBLEARRAY){
    std::cout << "DataType ERROR." << std::endl;
    return -1;
  }

  svc_flag = true;
  svc_type = datatype;
  svc_max  = limitmax;
  svc_min  = limitmin;

  return 0;
}

CORBA::Double limiterSVC_impl::GetLimitMax()
{
  return svc_max;
}

CORBA::Double limiterSVC_impl::GetLimitMin()
{
  return svc_min;
}

CORBA::Long limiterSVC_impl::SetLimitMax(CORBA::Double& limitmax)
{
  svc_max = limitmax;
  return 0;
}

CORBA::Long limiterSVC_impl::SetLimitMin(CORBA::Double& limitmin)
{
  svc_min = limitmin;
  return 0;
}



// End of example implementational code



