// -*-C++-*-
/*!
 * @file  LimiterSVC_impl.h
 * @brief Service implementation header of Limiter.idl
 *
 */

#include "LimiterSkel.h"


#ifndef LIMITERSVC_IMPL_H
#define LIMITERSVC_IMPL_H
 
/*
 * Example class implementing IDL interface limiter
 */
class limiterSVC_impl
 : public virtual POA_limiter,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~limiterSVC_impl();

 public:
   // standard constructor
   limiterSVC_impl();
   virtual ~limiterSVC_impl();

   // attributes and operations
   CORBA::Long SetStatus(CORBA::Long& datatype, CORBA::Double& limitmax, CORBA::Double& limitmin);
   CORBA::Double GetLimitMax();
   CORBA::Double GetLimitMin();
   CORBA::Long SetLimitMax(CORBA::Double& limitmax);
   CORBA::Long SetLimitMin(CORBA::Double& limitmin);

};



#endif // LIMITERSVC_IMPL_H


