// -*- C++ -*-
/*!
 * @file  Not.cpp
 * @brief Not component
 * $Date$
 *
 * $Id$
 */

#include "Not.h"
#include <iostream>

// Module specification
// <rtc-template block="module_spec">
static const char* not_spec[] =
  {
    "implementation_id", "Not",
    "type_name",         "Not",
    "description",       "Not component",
    "version",           "1.0",
    "vendor",            "MS_LAB",
    "category",          "",
    "activity_type",     "",
    "max_instance",      "",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

Not::Not(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_boolinIn("booleanin", m_boolin),
    m_booloutOut("booleanout", m_boolout),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  //registerInPort("datain", m_datainIn);
  
  // Set OutPort buffer
  //registerOutPort("dataout", m_dataoutOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

Not::~Not()
{
}


RTC::ReturnCode_t Not::onInitialize()
{
  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  
  // </rtc-template>
  std::cout << "Not start." << std::endl;
  return RTC::RTC_OK;
}



RTC::ReturnCode_t Not::onFinalize()
{
  RTC::Manager::instance().terminate();
  return RTC::RTC_OK;
}


bool activate_flag=true;

RTC::ReturnCode_t Not::onActivated(RTC::UniqueId ec_id)
{
  if(activate_flag){
    registerOutPort("booleanout", m_booloutOut);
    registerInPort("booleanin", m_boolinIn);
    activate_flag=false;
  }
  return RTC::RTC_OK;
}



RTC::ReturnCode_t Not::onDeactivated(RTC::UniqueId ec_id)
{
  m_boolinIn.read();

  return RTC::RTC_OK;
}



RTC::ReturnCode_t Not::onExecute(RTC::UniqueId ec_id)
{
  bool boolnum;

  if(m_boolinIn.isNew()){
    m_boolinIn.read();
    boolnum = m_boolin.data;

    if(boolnum)
      boolnum = false;
    else
      boolnum = true;

    m_boolout.data = boolnum;
    m_booloutOut.write();
  }

  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t Not::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Not::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Not::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Not::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t Not::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void NotInit(RTC::Manager* manager)
  {
    RTC::Properties profile(not_spec);
    manager->registerFactory(profile,
                             RTC::Create<Not>,
                             RTC::Delete<Not>);
  }
  
};


